;
; Startup code for cc65 
;
	.import	_cmain
	.import	_cirq
	.import	_cnmi
	.import _initdata
	.importzp   	sp
	.export _code_entry
.segment	"INTENTRY"
irqvector:
	.res	3
nmivector:
	.res	3
.segment	"CODE"
nmi_entry:
	pha
	phx
	phy
	jsr	nmivector
	ply
	plx
	pla
	rti

startup:
	ldx	#$ff
	txs
	lda	#<stktop
	sta	sp
	lda	#>stktop
	sta	sp+1
	lda	#$4c
	sta	irqvector
	lda	#<_cirq
	sta	irqvector+1
	lda	#>_cirq
	sta	irqvector+2

	lda	#$4c
	sta	nmivector
	lda	#<_cnmi
	sta	nmivector+1
	lda	#>_cnmi
	sta	nmivector+2

	jsr	_initdata
	jsr	_cmain
	bra	startup

irq_entry:
	pha
	phx
	phy
;	jsr	_cirq
	jsr	irqvector
	ply
	plx
	pla
	rti
.segment	"STACK"
	.res	1023
stktop:

.segment	"INITJUMP"
_code_entry:
	jmp	startup
.segment       	"VECTORS"
vector_nmi:
	.addr	nmi_entry
vector_reset:
	.addr	startup
vector_irqb:
	.addr	irq_entry
; ------------------------------------------------------------------------
