//--------------------------------
//-- PEACH-Ip}CNBASIC	--
//--------------------------------

//
// A-Z		Variable
// &		Program Head pointer
// =		Program END pointer
// .=100	LIST
// #=100	GOTO Line#
// !=100	GOSUB LINE#
// ]		RETURN
// ;= A=3	IF
// $= $D000	MACHINE GOSUB
// "TEXT"	PRINT STRING
// \		CR+LF
// ?=100	PRINT DECIMAL VALUE(10ij
// ?$=100	PRINT HEX2 VALUE(16i2j
// ??=100	PRINT HEX4 VALUE(16i4j
// ?#=$C	PRINT CHR$
// A:0)		MEMORY BYTE
// A(0)		WORD MEMORY

#include "ctype.h"
#include "print.h"
#include "cstdef.h"

extern unsigned char lbuf[];
extern unsigned char lbufpos;
extern unsigned char *sptr;
extern unsigned char cmdsts;
extern unsigned char *errmsg[];

extern unsigned char getline(void);
extern unsigned int get4hex(void);
extern void skipspace(void);
extern unsigned char scmp(unsigned char *, unsigned char *);

unsigned char *psptr;

unsigned int calc(void);
#define	EOP		0xffff

unsigned char	mb_mode;
#define	MB_EDIT		0	// GfBbg[h
#define	MB_EXEC		1	// s[h

#define	OP_NUL		0x00	//
#define	OP_LP		0x01	// (
#define	OP_RP		0x02	// )
#define	OP_OR		0x10	// |
#define	OP_XOR		0x20	// ^
#define	OP_AND		0x30	// &
#define	OP_EQ		0x40	// =
#define	OP_NEQ		0x41	// <>
#define	OP_GT		0x50	// >
#define	OP_LT		0x51	// <
#define	OP_GTEQ		0x52	// >=
#define	OP_LTEQ		0x53	// <=
#define	OP_ADD		0x60	// +
#define	OP_SUB		0x61	// -
#define	OP_MUL		0x70	// *
#define	OP_DIV		0x71	// /
#define	OP_MOD		0x72	// %
#define	OP_DEF		0xff	// Jn

unsigned int	variable[26];	// 'A''Z'AƁ
unsigned char	*prog_head;
unsigned char	*prog_tail;
unsigned int	prog_size;

#define	GOSUB_STKSIZE	16
unsigned char	*gosub_stk[GOSUB_STKSIZE];
unsigned char	gosub_stkp;

#pragma bssseg("PROG_BUF");
unsigned char	prog[1024];
#pragma bssseg("BSS");

unsigned int	areg, breg;
unsigned char	opr,opl;
unsigned char	plevel;

unsigned char getop(void)
{
	unsigned char op;
	skipspace();
	switch(*sptr) {
		case	'|':	op = OP_OR;  break;
		case	'^':	op = OP_XOR; break;
		case	'&':	op = OP_AND; break;
		case	'=':	op = OP_EQ;  break;
		case	'>':	if (*(sptr+1) == '=') {
					sptr++;
					op = OP_GTEQ;
				} else 	op = OP_GT;
				break;
		case	'<':	if (*(sptr+1) == '=') {
					sptr++;
					op = OP_LTEQ;
				} else if(*(sptr+1) == '>') {
					sptr++;
					op = OP_NEQ;
				} else	op = OP_LT;
				break;
		case	'+':	op = OP_ADD; break;
		case	'-':	op = OP_SUB; break;
		case	'*':	op = OP_MUL; break;
		case	'/':	op = OP_DIV; break;
		case	'%':	op = OP_MOD; break;
		case	')':	op = OP_RP;  break;
		default:	op = OP_NUL; break;
	}
	return(op);
}

unsigned int operation(unsigned int aval, unsigned int bval, unsigned char opr)
{
	unsigned int	val;
	switch(opr) {
		case	OP_OR:  val = aval | bval; break;
		case	OP_XOR: val = aval ^ bval; break;
		case	OP_AND: val = aval & bval; break;
		case	OP_EQ:  val = (aval == bval) ? 1: 0; break;
		case	OP_NEQ: val = (aval != bval) ? 1: 0; break;
		case	OP_GT:	val = (aval > bval) ? 1: 0; break;
		case	OP_LT:	val = (aval < bval) ? 1: 0; break;
		case	OP_GTEQ:val = (aval >= bval) ? 1: 0; break;
		case	OP_LTEQ:val = (aval <= bval) ? 1: 0; break;
		case	OP_ADD: val = aval + bval; break;
		case	OP_SUB: val = aval - bval; break;
		case	OP_MUL: val = aval * bval; break;
		case	OP_DIV: val = aval / bval; break;
		case	OP_MOD: val = aval % bval; break;
		case	OP_DEF: val = bval; break;		// X^[gȂbval̂
		case	OP_RP:	val = bval; break;
		case	OP_NUL:	val = 0; break;
		default:	val = 0; break;
	}
	return(val);
}

unsigned int get_adrs(unsigned char *wordflag)
{
	unsigned char	varnum;
	unsigned int	adr;
	if (*sptr == '&')		// ƃC`Lۂ̂
		varnum = 26;		// variable̎ɕׂprog_headɃANZX邱Ƃ
	else if (*sptr == '=')		// ꏏ
		varnum = 27;
	else	varnum = *sptr - 'A';
	sptr++;
	while (isalpha(*sptr))
		sptr++;
	if (*sptr == ':') {	// 8bitANZX
		*wordflag = 0;
		sptr++;
		adr = variable[varnum] + calc();
		if (*sptr != ')')
			cmdsts = E_ERRVAL;
		else	sptr++;
		return(adr);
	}
	*wordflag = 1;
	if (*sptr == '(') {	// 16bitANZX
		sptr++;
		adr = variable[varnum] + (calc() << 1);
		if (*sptr != ')')
			cmdsts = E_ERRVAL;
		else	sptr++;
		return(adr);
	}
	adr = (unsigned int)(&variable[varnum]);
	return(adr);
}

unsigned int getdecihex(void)
{
	unsigned int val;
	unsigned char minus;
	skipspace();
	val = 0;
	if (*sptr == '-') {
		sptr++;
		minus = 1;
	} else	minus = 0;
	if (*sptr == '$') {
		sptr++;
		if (!isxdigit(*sptr)) {
			cmdsts = E_ERRVAL;
			return(0);
		}
		while(isxdigit(*sptr)) {
			val = val*0x10 + ((*sptr <= '9') ? (*sptr -'0') : (*sptr - 'A' + 10));
			sptr++;
		}
	} else {
		if (!isdigit(*sptr)) {
			cmdsts = E_ERRVAL;
			return(0);
		}
		while(isdigit(*sptr)) {
			val = val * 10 + (*sptr - '0');
			sptr++;
		}
	}
	if (minus)
		val = -val;
	return(val);
}

unsigned int inputval(void)
{
	unsigned int val;
	if (mb_mode != MB_EXEC) {	// s[hłȂΖ
		cmdsts = E_ERRCMD;
		return(0);
	}
	psptr = sptr+1;			// sptrobNAbvĂ
	sptr = lbuf;
	getline();
	val = getdecihex();
	sptr = psptr;
	return(val);
}

unsigned int get_value()
{
	unsigned char	wordflag;
	unsigned int	adrs;
	unsigned int	val;
	unsigned char	minusflag;
	skipspace();
	if (*sptr == '-') {
		minusflag = 1;
		sptr++;
		skipspace();
	} else	minusflag = 0;
	if (*sptr == '(') {		// hih
		plevel++;		// h(hxグ
		sptr++;			// (̎̃LN^ʒuɍ킹
		val = calc();		// Zs
		if (minusflag)
			val = -val;
		if (*sptr == ')') {	// hjhŕĂ琬
			sptr++;		// )̌ɐi߂
			return(val);
		} else {		// ĂȂG[
			cmdsts = E_ERRVAL;
			return(0);
		}
	}
	if (isalpha(*sptr) || (*sptr == '&') || (*sptr == '=')) {
		adrs = get_adrs(&wordflag);
		if (wordflag)
			val = *(unsigned int *)adrs;
		else	val = *(unsigned char *)adrs;
		if (minusflag)
			val = -val;
 		return(val);
	}
	if (*sptr == '?') {
		val = inputval();
		if (minusflag)
			val = -val;
		return(val);
	}
	val = getdecihex();
	if (minusflag)
		val = -val;
	return(val);
}

unsigned int calc(void)
{
	unsigned int	stk_aval[4];
	unsigned char	stk_op[4];
	unsigned char	opp;
	unsigned char	popr;
	unsigned char	copr;
	unsigned int	bval;
	opp = 1;
	popr = OP_DEF;
	skipspace();
	bval = get_value();
	while(cmdsts == E_READY) {
		copr = getop();				// Zq捞
		if ((popr & 0xf0) >= (copr & 0xf0)) {	// VZq̗DxȉȂX^bNƉZs
			opp--;
			bval = operation(stk_aval[opp], bval, popr);
			if ((copr == OP_RP) || (copr == OP_NUL)) {		// "jh̖
				while (opp) {					// X^bNقԂĉZ
					opp--;
					bval = operation(stk_aval[opp], bval, stk_op[opp]);
				}
				return(bval);
			}
			sptr++;
			stk_op[opp] = copr;		// ̉Zq
			stk_aval[opp] = bval;		// ̉Zς݂̒lς
		} else {				// VZq̗Dx̕
			sptr++;
			stk_op[opp]   = copr;		// VZq
			stk_aval[opp] = bval;		// ̉Zς݂̒lX^bNɐς
		}
		opp++;
		popr = copr;
		bval = get_value();			// ̒l擾
	}
	return(0);
}


void mb_prints(void)
{
	unsigned char base;
	while(isprint(base = *sptr)) {
		if (base =='"') {
			sptr++;
			break;
		}
		putc(*sptr++);
	}
}

void mb_printcr(void)
{
	puts("\r\n");
}

void mb_printval(void)
{
	unsigned char base;
	unsigned int val;
	switch(*sptr) {
		case '=':
			base = 0;
			break;
		case '$':
			base = 1;
			sptr++;
			break;
		case '?':
			base = 2;
			sptr++;
			break;
		case '#':
			base = 3;
			sptr++;
			break;
		default:
			base = 0xff;
			break;
	}
	skipspace();
	if ((*sptr != '=') || (base == 0xff)) {
		cmdsts = E_ERRCMD;
		return;
	}
	sptr++;
	plevel = 0;
	val = calc();
	if (cmdsts != E_READY)
		return;
	switch(base) {
		case 0:	printf("%d",val); break;
		case 1:	printf("%02x",val); break;
		case 2:	printf("%04x",val); break;
		default: printf("%c",val); break;
	}
}

void goto_eol()
{
	while(*sptr != EOS)
		sptr++;
}

//
//w肳ꂽsԍȏ̍sT
//
search_line(unsigned int lnum)
{
	while (*(unsigned int*)sptr < lnum) {
		sptr += 2;	// sԍf[^Ƃ΂
		goto_eol();	// s܂ňړ
		sptr++;		// EOSƂ΂
	}
}

unsigned char *search_end()
{
	unsigned char *s;
	s = prog_head;
	while(*(unsigned int *)s  < 0x8000) {	// sԍ0x8000Ȃ
		s += 2;		// sԍ΂
		while (*s++ != EOS)
			;
	}
	s += 2;
	prog_tail = s;
	*s = EOS;
	return(s);
}

//
// ݂sptrƂ̍s폜
//
void delete_line()
{
	unsigned char *s,*d;
	if (*(unsigned int *)sptr >= 0x8000)	// ̍sԍ0x8000ȏȂvO
		return;
	d = sptr;	// Ҕ
	sptr += 2;	// sԍf[^Ƃ΂
	goto_eol();	// s܂ňړ
	s = sptr+1;	// ̍s
	sptr = d;	// ̈ʒuɖ߂Ă
	do {
		*d++ = *s++;	// sԍ
	} while (s < prog_tail);
}

unsigned int strlen(unsigned char *s)
{
	unsigned int i;
	for (i=0; *s != EOS; i++,s++)
		;
	return(i);
}

//
// sԍFlnumber
// sԍȉFsptr
// prog_headȍ~ɂvOɑ}
//

void linsert(unsigned int lnumber)
{
	unsigned int i;
	unsigned char *sbk,*s,*d;
	if ((lnumber >= 0x8000) || (!lnumber)) {
		puts("?? Line#\r\n");
		return;
	}
	sbk = sptr;		// sptrʒuۑ
	sptr = prog_head;	// vO擪wĂ
	search_line(lnumber);	// }ʒu
	search_end();	// vOZbgAbv
	if (*(unsigned int *)sptr == lnumber) // sԍvĂ폜
		delete_line();
	s = search_end();	// vOZbgAbv
	i = strlen(sbk);
	if (i > 0) {
		d = s+i+3;
		while(s > sptr)
			*d-- = *s--;
		*d = *s;
		*(unsigned int *)s = lnumber;
		d = s+2;	// sԍ{{
		s = sbk;
		while(i--)
			*d++ = *s++;
		*d = EOS;
		search_end();	// vOZbgAbv
	}
}

void prog_list(unsigned int lnumber)
{
	unsigned int l;
	unsigned char *c;
	c = sptr;
	sptr = prog_head;
	search_line(lnumber);
	while(1) {
		if ((l = *(unsigned int *)sptr) < 0x8000) {
			printf("%d",l);
			sptr += 2;
			printf("%s\n",sptr);
			goto_eol();
			sptr++;
		} else	break;
	}
	sptr = c;
}

//
// 'R}h  f̌`̏
//
unsigned int eqcalc(void)
{
	skipspace();
	if (*sptr != '=') {
		cmdsts = E_ERRCMD;
		return(0);
	}
	sptr++;
	return(calc());
}

void mb_goto(void)
{
	unsigned int val;
	val = eqcalc();
	if (cmdsts != E_READY)
		return;
	sptr = prog_head;
	search_line(val);
	sptr--;			// O̍s̏I|CgĂ
	mb_mode = MB_EXEC;	// _CNg[hp
}

void mb_gosub()
{
	unsigned int val;
	if (mb_mode != MB_EXEC) {
		cmdsts = E_ERRCMD;
		return;
	}
	if (gosub_stkp >= GOSUB_STKSIZE) {
		cmdsts = E_ERRSTK;
		return;
	}
	val = eqcalc();
	if (cmdsts != E_READY)
		return;
	gosub_stk[gosub_stkp] = sptr;
	gosub_stkp++;
	sptr = prog_head;
	search_line(val);
	sptr--;			// O̍s̏I|CgĂ
}

void mb_return(void)
{
	if (mb_mode != MB_EXEC) {
		cmdsts = E_ERRCMD;
		return;
	}
	if (!gosub_stkp) {
		cmdsts = E_ERRSTK;
		return;
	}
	gosub_stkp--;
	sptr = gosub_stk[gosub_stkp];
}


unsigned char exitflag;
static void (*fp)(void);
void mb_line(void)
{
	unsigned int val,adrs;
	unsigned char wordflag;
	while((*sptr != EOS) && (cmdsts == E_READY)) {
		skipspace();
		if (isalpha(*sptr) || (*sptr == '&') || (*sptr == '=')) {	// ϐANZX
			adrs = get_adrs(&wordflag);
			val = eqcalc();
			if (cmdsts != E_READY)
				break;
			if (wordflag)
				*(unsigned int *)adrs = val;
			else	*(unsigned char *)adrs = val;
			continue;
		}
		switch(*sptr++) {
			case '"':
				mb_prints();
				break;
			case '\\':
				mb_printcr();
				break;
			case '?':		// print
				mb_printval();
				break;
			case ';':		// IF
				if (!(val = eqcalc()))
					goto_eol();
				break;
			case '$':		// Machine Gosub
				val = eqcalc();
				if (cmdsts == E_READY) {
					fp = (void *())val;
					__asm__("php");
					__asm__("sei");
					fp();
					__asm__("plp");
				}
				break;
			case '.':
				if (*sptr != '=') {
					val = 0;
				} else {
					val = eqcalc();
					if (cmdsts != E_READY)
						break;
				}
				prog_list(val);
				break;
			case '#':
				mb_goto();
				return;
			case '!':
				mb_gosub();
				return;
			case ']':
				mb_return();
				break;
			case '\'':
				goto_eol();
				break;
			default: 
				cmdsts = E_ERRCMD;
				break;
		}
	}
}

void mbasic(void)
{
	unsigned int lnumber;
	unsigned char c;
	for (c=0; c<26; c++)
		variable[c] = c;
	prog_head = prog;
	prog_tail = prog;
	prog_size = 0;
	mb_mode = MB_EDIT;
	*(unsigned int *)prog_head = EOP;	// End Of Program
	puts("******** Micro BASIC for PEACH-I ********");
	c = 1;
	while(1) {
		if (c)
			puts("\r\nOK.\r\n");
		cmdsts = E_READY;
		getline();
		sptr = lbuf;
		if (scmp(sptr, "EXIT"))
			break;
		lnumber = getdecihex();		// 擪̍sԍ擾
		if (cmdsts == E_READY) {	// sԍ
			c = 0;
			linsert(lnumber);	// s}i܂͍폜j
		} else {
			cmdsts = E_READY;
			mb_line();		// Ⴀ_CNg[h낤
			gosub_stkp = 0;
			while((mb_mode == MB_EXEC) && (cmdsts == E_READY)) {
				sptr++;
				lnumber =*(unsigned int *)sptr;
				if (lnumber < 0x8000) {
					sptr += 2;
					mb_line();
				} else {
					break;
				}
			}
			mb_mode = MB_EDIT;
			c = 1;
		}
		if (cmdsts != E_READY) {
			printf("\n%s",errmsg[cmdsts]);
			printf("[Line#%d]\n",lnumber);
		}
	}
}

